
package de.ivu.elect.presentation.kandidatur.menu;

import static java.util.Collections.singletonList;
import static java.util.stream.Collectors.toList;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.menu.DokumentErzeugenMenuItemEntry;
import de.ivu.elect.presentation.kandidatur.DirektkandidaturSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlag.dokumente.WahlvorschlaegeAlsListeDokumentErzeugenView;

public class DirektkandidaturWahlvorschlaegeAlsListeDokumentErzeugenMenuItemEntry extends AbstractMenuItemEntry implements DokumentErzeugenMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient GebietSessionSelect gebietSessionSelect;

  @View
  @Inject
  private transient DirektkandidaturSearchView direktkandidaturSearchView;

  @View
  @Inject
  private transient WahlvorschlaegeAlsListeDokumentErzeugenView wahlvorschlaegeAlsListeDokumentErzeugenView;

  public DirektkandidaturWahlvorschlaegeAlsListeDokumentErzeugenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.DOKUMENT_ERZEUGEN_WAHLVORSCHLAEGE_ALS_LISTE);
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal() {
    return !gebietSessionSelect.isSelected();
  }

  @Override
  public String getTargetViewId() {
    return null; // doAction!
  }

  @Override
  @Redirect
  public String doAction() {
    return wahlvorschlaegeAlsListeDokumentErzeugenView.initWahlvorschlaege(direktkandidaturSearchView.getSearchResult().stream().map(Direktkandidatur::getDirektkandidat).collect(toList()));
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return singletonList(WahlvorschlaegeAlsListeDokumentErzeugenView.VIEW_ID);
  }

  @Override
  public String getLabelKey() {
    return "direktkandidatur.action.wahlvorschlaege.drucken";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconPrint();
  }
}
